/* window.c generated by valac 0.56.18, the Vala compiler
 * generated from window.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define MINE_WINDOW_KEY_THEME "theme"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MINE_WINDOW (mine_window_get_type ())
#define MINE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINE_WINDOW, MineWindow))
#define MINE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINE_WINDOW, MineWindowClass))
#define IS_MINE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINE_WINDOW))
#define IS_MINE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINE_WINDOW))
#define MINE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINE_WINDOW, MineWindowClass))

typedef struct _MineWindow MineWindow;
typedef struct _MineWindowClass MineWindowClass;
typedef struct _MineWindowPrivate MineWindowPrivate;
enum  {
	MINE_WINDOW_0_PROPERTY,
	MINE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* mine_window_properties[MINE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MineWindow {
	GtkApplicationWindow parent_instance;
	MineWindowPrivate * priv;
};

struct _MineWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _MineWindowPrivate {
	GSettings* settings;
	GtkCssProvider* theme_provider;
};

static gint MineWindow_private_offset;
static gpointer mine_window_parent_class = NULL;

VALA_EXTERN GType mine_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MineWindow, g_object_unref)
static gboolean mine_window_real_close_request (GtkWindow* base);
static void mine_window_save_window_state (MineWindow* self);
static void mine_window_load_window_state (MineWindow* self);
static void mine_window_set_game_theme (MineWindow* self,
                                 const gchar* theme);
VALA_EXTERN MineWindow* mine_window_new (void);
VALA_EXTERN MineWindow* mine_window_construct (GType object_type);
static GObject * mine_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _mine_window___lambda4_ (MineWindow* self);
static void __mine_window___lambda4__g_settings_changed (GSettings* _sender,
                                                  const gchar* key,
                                                  gpointer self);
static void mine_window_finalize (GObject * obj);
static GType mine_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
mine_window_get_instance_private (MineWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MineWindow_private_offset);
}

static gboolean
mine_window_real_close_request (GtkWindow* base)
{
	MineWindow * self;
	gboolean result;
#line 31 "../src/window.vala"
	self = (MineWindow*) base;
#line 33 "../src/window.vala"
	mine_window_save_window_state (self);
#line 35 "../src/window.vala"
	result = GTK_WINDOW_CLASS (mine_window_parent_class)->close_request ((GtkWindow*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow));
#line 35 "../src/window.vala"
	return result;
#line 122 "window.c"
}

static void
mine_window_load_window_state (MineWindow* self)
{
	gboolean window_maximized = FALSE;
	GSettings* _tmp0_;
#line 38 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/window.vala"
	_tmp0_ = self->priv->settings;
#line 40 "../src/window.vala"
	window_maximized = g_settings_get_boolean (_tmp0_, "window-is-maximized");
#line 42 "../src/window.vala"
	if (window_maximized) {
#line 43 "../src/window.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 140 "window.c"
	} else {
		gint width = 0;
		GSettings* _tmp1_;
		gint height = 0;
		GSettings* _tmp2_;
#line 45 "../src/window.vala"
		_tmp1_ = self->priv->settings;
#line 45 "../src/window.vala"
		width = g_settings_get_int (_tmp1_, "window-width");
#line 46 "../src/window.vala"
		_tmp2_ = self->priv->settings;
#line 46 "../src/window.vala"
		height = g_settings_get_int (_tmp2_, "window-height");
#line 47 "../src/window.vala"
		gtk_window_set_default_size ((GtkWindow*) self, width, height);
#line 156 "window.c"
	}
}

static void
mine_window_save_window_state (MineWindow* self)
{
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
#line 51 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/window.vala"
	width = 0;
#line 54 "../src/window.vala"
	height = 0;
#line 56 "../src/window.vala"
	gtk_window_get_default_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 56 "../src/window.vala"
	width = _tmp0_;
#line 56 "../src/window.vala"
	height = _tmp1_;
#line 58 "../src/window.vala"
	g_debug ("window.vala:58: Saving window geometry: %i × %i", width, height);
#line 60 "../src/window.vala"
	_tmp2_ = self->priv->settings;
#line 60 "../src/window.vala"
	g_settings_set_int (_tmp2_, "window-width", width);
#line 61 "../src/window.vala"
	_tmp3_ = self->priv->settings;
#line 61 "../src/window.vala"
	g_settings_set_int (_tmp3_, "window-height", height);
#line 63 "../src/window.vala"
	_tmp4_ = self->priv->settings;
#line 63 "../src/window.vala"
	g_settings_set_boolean (_tmp4_, "window-is-maximized", gtk_window_is_maximized ((GtkWindow*) self));
#line 196 "window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 70 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 204 "window.c"
}

static void
mine_window_set_game_theme (MineWindow* self,
                            const gchar* theme)
{
	gchar* theme_path = NULL;
	gchar* _tmp0_;
	gboolean is_switch = FALSE;
	GtkCssProvider* _tmp1_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp2_;
	GdkDisplay* _tmp3_;
	const gchar* _tmp4_;
	gchar* theme_css_path = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GtkCssProvider* _tmp25_;
	GtkCssProvider* _tmp26_;
	const gchar* _tmp27_;
	GdkDisplay* _tmp28_;
	GtkCssProvider* _tmp29_;
#line 66 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/window.vala"
	g_return_if_fail (theme != NULL);
#line 68 "../src/window.vala"
	_tmp0_ = g_strdup (theme);
#line 68 "../src/window.vala"
	theme_path = _tmp0_;
#line 69 "../src/window.vala"
	_tmp1_ = self->priv->theme_provider;
#line 69 "../src/window.vala"
	is_switch = _tmp1_ != NULL;
#line 70 "../src/window.vala"
	_tmp2_ = gtk_root_get_display ((GtkRoot*) self);
#line 70 "../src/window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 70 "../src/window.vala"
	display = _tmp3_;
#line 72 "../src/window.vala"
	_tmp4_ = theme_path;
#line 72 "../src/window.vala"
	if (!g_path_is_absolute (_tmp4_)) {
#line 249 "window.c"
		gchar* _tmp5_;
#line 73 "../src/window.vala"
		_tmp5_ = g_build_path (G_DIR_SEPARATOR_S, DATA_DIRECTORY, "themes", theme, NULL);
#line 73 "../src/window.vala"
		_g_free0 (theme_path);
#line 73 "../src/window.vala"
		theme_path = _tmp5_;
#line 257 "window.c"
	}
#line 75 "../src/window.vala"
	if (!is_switch) {
#line 261 "window.c"
		GdkDisplay* _tmp6_;
		GtkIconTheme* _tmp7_;
		const gchar* _tmp8_;
#line 76 "../src/window.vala"
		_tmp6_ = display;
#line 76 "../src/window.vala"
		_tmp7_ = gtk_icon_theme_get_for_display (_tmp6_);
#line 76 "../src/window.vala"
		_tmp8_ = theme_path;
#line 76 "../src/window.vala"
		gtk_icon_theme_add_search_path (_tmp7_, _tmp8_);
#line 273 "window.c"
	} else {
		GtkIconTheme* icon_theme = NULL;
		GdkDisplay* _tmp9_;
		GtkIconTheme* _tmp10_;
		GtkIconTheme* _tmp11_;
		gchar** icon_search_path = NULL;
		GtkIconTheme* _tmp12_;
		gchar** _tmp13_;
		gchar** _tmp14_;
		gint icon_search_path_length1;
		gint _icon_search_path_size_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		GtkIconTheme* _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
#line 78 "../src/window.vala"
		_tmp9_ = display;
#line 78 "../src/window.vala"
		_tmp10_ = gtk_icon_theme_get_for_display (_tmp9_);
#line 78 "../src/window.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 78 "../src/window.vala"
		icon_theme = _tmp11_;
#line 79 "../src/window.vala"
		_tmp12_ = icon_theme;
#line 79 "../src/window.vala"
		_tmp14_ = _tmp13_ = gtk_icon_theme_get_search_path (_tmp12_);
#line 79 "../src/window.vala"
		icon_search_path = _tmp14_;
#line 79 "../src/window.vala"
		icon_search_path_length1 = _vala_array_length (_tmp13_);
#line 79 "../src/window.vala"
		_icon_search_path_size_ = icon_search_path_length1;
#line 80 "../src/window.vala"
		_tmp15_ = icon_search_path;
#line 80 "../src/window.vala"
		_tmp15__length1 = icon_search_path_length1;
#line 80 "../src/window.vala"
		_tmp16_ = icon_search_path;
#line 80 "../src/window.vala"
		_tmp16__length1 = icon_search_path_length1;
#line 80 "../src/window.vala"
		_tmp17_ = theme_path;
#line 80 "../src/window.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 80 "../src/window.vala"
		_g_free0 (_tmp15_[_tmp16__length1 - 1]);
#line 80 "../src/window.vala"
		_tmp15_[_tmp16__length1 - 1] = _tmp18_;
#line 81 "../src/window.vala"
		_tmp19_ = icon_theme;
#line 81 "../src/window.vala"
		_tmp20_ = icon_search_path;
#line 81 "../src/window.vala"
		_tmp20__length1 = icon_search_path_length1;
#line 81 "../src/window.vala"
		gtk_icon_theme_set_search_path (_tmp19_, _tmp20_);
#line 75 "../src/window.vala"
		icon_search_path = (_vala_array_free (icon_search_path, icon_search_path_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/window.vala"
		_g_object_unref0 (icon_theme);
#line 340 "window.c"
	}
#line 84 "../src/window.vala"
	_tmp21_ = theme_path;
#line 84 "../src/window.vala"
	_tmp22_ = g_build_filename (_tmp21_, "theme.css", NULL);
#line 84 "../src/window.vala"
	theme_css_path = _tmp22_;
#line 85 "../src/window.vala"
	if (is_switch) {
#line 350 "window.c"
		GdkDisplay* _tmp23_;
		GtkCssProvider* _tmp24_;
#line 86 "../src/window.vala"
		_tmp23_ = display;
#line 86 "../src/window.vala"
		_tmp24_ = self->priv->theme_provider;
#line 86 "../src/window.vala"
		gtk_style_context_remove_provider_for_display (_tmp23_, (GtkStyleProvider*) _tmp24_);
#line 359 "window.c"
	}
#line 88 "../src/window.vala"
	_tmp25_ = gtk_css_provider_new ();
#line 88 "../src/window.vala"
	_g_object_unref0 (self->priv->theme_provider);
#line 88 "../src/window.vala"
	self->priv->theme_provider = _tmp25_;
#line 89 "../src/window.vala"
	_tmp26_ = self->priv->theme_provider;
#line 89 "../src/window.vala"
	_tmp27_ = theme_css_path;
#line 89 "../src/window.vala"
	gtk_css_provider_load_from_path (_tmp26_, _tmp27_);
#line 90 "../src/window.vala"
	_tmp28_ = display;
#line 90 "../src/window.vala"
	_tmp29_ = self->priv->theme_provider;
#line 90 "../src/window.vala"
	gtk_style_context_add_provider_for_display (_tmp28_, (GtkStyleProvider*) _tmp29_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 92 "../src/window.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 66 "../src/window.vala"
	_g_free0 (theme_css_path);
#line 66 "../src/window.vala"
	_g_object_unref0 (display);
#line 66 "../src/window.vala"
	_g_free0 (theme_path);
#line 387 "window.c"
}

MineWindow*
mine_window_construct (GType object_type)
{
	MineWindow * self = NULL;
#line 11 "../src/window.vala"
	self = (MineWindow*) g_object_new (object_type, NULL);
#line 11 "../src/window.vala"
	return self;
#line 398 "window.c"
}

MineWindow*
mine_window_new (void)
{
#line 11 "../src/window.vala"
	return mine_window_construct (TYPE_MINE_WINDOW);
#line 406 "window.c"
}

static void
_mine_window___lambda4_ (MineWindow* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 25 "../src/window.vala"
	_tmp0_ = self->priv->settings;
#line 25 "../src/window.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, MINE_WINDOW_KEY_THEME);
#line 25 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 25 "../src/window.vala"
	mine_window_set_game_theme (self, _tmp2_);
#line 25 "../src/window.vala"
	_g_free0 (_tmp2_);
#line 425 "window.c"
}

static void
__mine_window___lambda4__g_settings_changed (GSettings* _sender,
                                             const gchar* key,
                                             gpointer self)
{
#line 24 "../src/window.vala"
	_mine_window___lambda4_ ((MineWindow*) self);
#line 435 "window.c"
}

static GObject *
mine_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MineWindow * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GSettings* _tmp4_;
	gchar* _tmp5_;
#line 19 "../src/window.vala"
	parent_class = G_OBJECT_CLASS (mine_window_parent_class);
#line 19 "../src/window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 19 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINE_WINDOW, MineWindow);
#line 21 "../src/window.vala"
	_tmp0_ = g_settings_new ("org.gnome.Mines");
#line 21 "../src/window.vala"
	_g_object_unref0 (self->priv->settings);
#line 21 "../src/window.vala"
	self->priv->settings = _tmp0_;
#line 23 "../src/window.vala"
	_tmp1_ = self->priv->settings;
#line 23 "../src/window.vala"
	_tmp2_ = g_settings_get_string (_tmp1_, MINE_WINDOW_KEY_THEME);
#line 23 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 23 "../src/window.vala"
	mine_window_set_game_theme (self, _tmp3_);
#line 23 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 24 "../src/window.vala"
	_tmp4_ = self->priv->settings;
#line 24 "../src/window.vala"
	_tmp5_ = g_strconcat ("changed::", MINE_WINDOW_KEY_THEME, NULL);
#line 24 "../src/window.vala"
	g_signal_connect_object (_tmp4_, _tmp5_, (GCallback) __mine_window___lambda4__g_settings_changed, self, 0);
#line 24 "../src/window.vala"
	_g_free0 (_tmp5_);
#line 28 "../src/window.vala"
	mine_window_load_window_state (self);
#line 19 "../src/window.vala"
	return obj;
#line 486 "window.c"
}

static void
mine_window_class_init (MineWindowClass * klass,
                        gpointer klass_data)
{
#line 11 "../src/window.vala"
	mine_window_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &MineWindow_private_offset);
#line 11 "../src/window.vala"
	((GtkWindowClass *) klass)->close_request = (gboolean (*) (GtkWindow*)) mine_window_real_close_request;
#line 11 "../src/window.vala"
	G_OBJECT_CLASS (klass)->constructor = mine_window_constructor;
#line 11 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = mine_window_finalize;
#line 503 "window.c"
}

static void
mine_window_instance_init (MineWindow * self,
                           gpointer klass)
{
#line 11 "../src/window.vala"
	self->priv = mine_window_get_instance_private (self);
#line 512 "window.c"
}

static void
mine_window_finalize (GObject * obj)
{
	MineWindow * self;
#line 11 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINE_WINDOW, MineWindow);
#line 14 "../src/window.vala"
	_g_object_unref0 (self->priv->settings);
#line 15 "../src/window.vala"
	_g_object_unref0 (self->priv->theme_provider);
#line 11 "../src/window.vala"
	G_OBJECT_CLASS (mine_window_parent_class)->finalize (obj);
#line 527 "window.c"
}

static GType
mine_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MineWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mine_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MineWindow), 0, (GInstanceInitFunc) mine_window_instance_init, NULL };
	GType mine_window_type_id;
	mine_window_type_id = g_type_register_static (gtk_application_window_get_type (), "MineWindow", &g_define_type_info, 0);
	MineWindow_private_offset = g_type_add_instance_private (mine_window_type_id, sizeof (MineWindowPrivate));
	return mine_window_type_id;
}

GType
mine_window_get_type (void)
{
	static volatile gsize mine_window_type_id__once = 0;
	if (g_once_init_enter (&mine_window_type_id__once)) {
		GType mine_window_type_id;
		mine_window_type_id = mine_window_get_type_once ();
		g_once_init_leave (&mine_window_type_id__once, mine_window_type_id);
	}
	return mine_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

